#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <wchar.h>



size_t
mbstowcs_l(wchar_t *dest, const char *src, size_t n, const char *locale)
{
    const char *lc_ctype;
    size_t ret;

    lc_ctype = setlocale(LC_CTYPE, NULL);
    if (lc_ctype == NULL)
        return (size_t)-1;

    if (setlocale(LC_CTYPE, locale) == NULL)
        return (size_t)-1;

    ret = mbstowcs(dest, src, n);
    setlocale(LC_CTYPE, lc_ctype);
    return ret;
}


int
main(void)
{
    wchar_t buf[100];
    char input[] = "abcdefghijklmnopq";
    size_t size;
    int i;

    setlocale(LC_CTYPE, "en_US.UTF-8");

    size = mbstowcs(NULL, input, -1);

    for (i = 0; i < 10000000; i++) {
        if (mbstowcs_l(buf, input, size, "en_US.UTF-8") == (size_t)-1) {
        // if (mbstowcs(buf, input, size) == (size_t)-1) {
            fprintf(stderr, "FAIL\n");
            return 1;
        }
        input[0] = (unsigned)buf[0] % 26 + 'a';
    }

    printf("%d\n", input[0]);
    return 0;
}
        

